VTK: vtkPSystemTools Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkPSystemTools Class Reference

System tools for file system introspection. More...

`#include <vtkPSystemTools.h>`

Inheritance diagram for vtkPSystemTools:
[legend]
Collaboration diagram for vtkPSystemTools:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPSystemTools * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkPSystemTools * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPSystemTools * | SafeDownCast (vtkObjectBase *o)
static void | BroadcastString (std::string &, int proc)
| Given a string on process proc, broadcast that string to all of the other processes. More...
static VTK_FILEPATH std::string | CollapseFullPath (VTK_FILEPATH const std::string &in_relative)
| Given a path to a file or directory, convert it to a full path. More...
static VTK_FILEPATH std::string | CollapseFullPath (VTK_FILEPATH const std::string &in_relative, VTK_FILEPATH const char *in_base)
static bool | FileIsDirectory (VTK_FILEPATH const std::string &name)
| Return true if the file is a directory. More...
static bool | FindProgramPath (const char *argv0, std::string &pathOut, std::string &errorMsg, const char *exeName=nullptr, const char *buildDir=nullptr, const char *installPrefix=nullptr)
| Given argv[0] for a unix program find the full path to a running executable. More...
static VTK_FILEPATH std::string | GetCurrentWorkingDirectory (bool collapse=true)
| Get current working directory CWD. More...
static VTK_FILEPATH std::string | GetProgramPath (VTK_FILEPATH const std::string &)
| Given the path to a program executable, get the directory part of the path with the file stripped off. More...
static bool | FileExists (VTK_FILEPATH const char *filename, bool isFile)
| Return true if a file exists in the current directory. More...
static bool | FileExists (VTK_FILEPATH const std::string &filename, bool isFile)
| Return true if a file exists in the current directory. More...
static bool | FileExists (VTK_FILEPATH const char *filename)
| Return true if a file exists in the current directory. More...
static bool | FileExists (VTK_FILEPATH const std::string &filename)
| Return true if a file exists in the current directory. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPSystemTools ()=default
| ~vtkPSystemTools () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

System tools for file system introspection.

A class with only static methods for doing parallel file system introspection. It limits doing file stats on process 0 and broadcasting the results to other processes. It is built on VTK's SystemTools class and uses the global controller for communication. It uses blocking collective communication operations.

Tests:
  vtkPSystemTools (Tests)

Definition at line 25 of file vtkPSystemTools.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkPSystemTools::Superclass

Definition at line 29 of file vtkPSystemTools.h.

## Constructor & Destructor Documentation

## ◆ vtkPSystemTools()

vtkPSystemTools::vtkPSystemTools | ( |  | ) |
| protecteddefault

## ◆ ~vtkPSystemTools()

vtkPSystemTools::~vtkPSystemTools | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ New()

static vtkPSystemTools* vtkPSystemTools::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkPSystemTools::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPSystemTools::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkPSystemTools* vtkPSystemTools::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPSystemTools::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkPSystemTools* vtkPSystemTools::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPSystemTools::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ BroadcastString()

static void vtkPSystemTools::BroadcastString | ( | std::string & | ,
|  | int | proc
| ) |  |
| static

Given a string on process proc, broadcast that string to all of the other processes.

This method does not have a correspondence to anything in SystemTools.

## ◆ CollapseFullPath() [1/2]

static VTK_FILEPATH std::string vtkPSystemTools::CollapseFullPath | ( | VTK_FILEPATH const std::string & | in_relative | ) |
| static

Given a path to a file or directory, convert it to a full path.

This collapses away relative paths relative to the cwd argument (which defaults to the current working directory). The full path is returned.

## ◆ CollapseFullPath() [2/2]

static VTK_FILEPATH std::string vtkPSystemTools::CollapseFullPath | ( | VTK_FILEPATH const std::string & | in_relative,
|  | VTK_FILEPATH const char * | in_base
| ) |  |
| static

## ◆ FileExists() [1/4]

static bool vtkPSystemTools::FileExists | ( | VTK_FILEPATH const char * | filename,
|  | bool | isFile
| ) |  |
| static

Return true if a file exists in the current directory.

If isFile = true, then make sure the file is a file and not a directory. If isFile = false, then return true if it is a file or a directory. Note that the file will also be checked for read access. (Currently, this check for read access is only done on POSIX systems.)

## ◆ FileExists() [2/4]

static bool vtkPSystemTools::FileExists | ( | VTK_FILEPATH const std::string & | filename,
|  | bool | isFile
| ) |  |
| static

Return true if a file exists in the current directory.

If isFile = true, then make sure the file is a file and not a directory. If isFile = false, then return true if it is a file or a directory. Note that the file will also be checked for read access. (Currently, this check for read access is only done on POSIX systems.)

## ◆ FileExists() [3/4]

static bool vtkPSystemTools::FileExists | ( | VTK_FILEPATH const char * | filename | ) |
| static

Return true if a file exists in the current directory.

If isFile = true, then make sure the file is a file and not a directory. If isFile = false, then return true if it is a file or a directory. Note that the file will also be checked for read access. (Currently, this check for read access is only done on POSIX systems.)

## ◆ FileExists() [4/4]

static bool vtkPSystemTools::FileExists | ( | VTK_FILEPATH const std::string & | filename | ) |
| static

Return true if a file exists in the current directory.

If isFile = true, then make sure the file is a file and not a directory. If isFile = false, then return true if it is a file or a directory. Note that the file will also be checked for read access. (Currently, this check for read access is only done on POSIX systems.)

## ◆ FileIsDirectory()

static bool vtkPSystemTools::FileIsDirectory | ( | VTK_FILEPATH const std::string & | name | ) |
| static

Return true if the file is a directory.

## ◆ FindProgramPath()

static bool vtkPSystemTools::FindProgramPath | ( | const char * | argv0,
|  | std::string & | pathOut,
|  | std::string & | errorMsg,
|  | const char * | exeName = `nullptr`,
|  | const char * | buildDir = `nullptr`,
|  | const char * | installPrefix = `nullptr`
| ) |  |
| static

Given argv[0] for a unix program find the full path to a running executable.

argv0 can be null for windows WinMain programs in this case GetModuleFileName will be used to find the path to the running executable. If argv0 is not a full path, then this will try to find the full path. If the path is not found false is returned, if found true is returned. An error message of the attempted paths is stored in errorMsg. exeName is the name of the executable. buildDir is a possibly null path to the build directory. installPrefix is a possibly null pointer to the install directory.

## ◆ GetCurrentWorkingDirectory()

static VTK_FILEPATH std::string vtkPSystemTools::GetCurrentWorkingDirectory | ( | bool | collapse = `true` | ) |
| static

Get current working directory CWD.

## ◆ GetProgramPath()

static VTK_FILEPATH std::string vtkPSystemTools::GetProgramPath | ( | VTK_FILEPATH const std::string & |  | ) |
| static

Given the path to a program executable, get the directory part of the path with the file stripped off.

If there is no directory part, the empty string is returned.

The documentation for this class was generated from the following file:

- Parallel/Core/vtkPSystemTools.h